TARGET = CamMarkLib
TEMPLATE = lib

CONFIG += staticlib
CONFIG += c++11

QMAKE_CXXFLAGS += -std=c++11

HEADERS += \
    calibration/CalibAGC.h \
    calibration/CalibSpatial.h \
    calibration/CalibTemporal.h \
    calibration/CalibTemporalMarker.h \
    common/Frame.h \
    common/FrameSequence.h \
    common/Scenario.h \
    image-registration/features.h \
    image-registration/params.h \
    image-registration/registration.h \
    image-registration/remapping.h \
    resources/marker_xo_images.h \
    include/CamMark_Calibration.h \
    include/CamMark_Simulation.h \
    simulation/SimAGC.h \
    simulation/SimAWB.h \
    simulation/SimBayerCFA.h \
    simulation/SimSpatial.h \
    simulation/SimDisplayPWM.h \
    simulation/SimTemporal.h \
    simulation/Simulation.h \
    stdafx.h \
    third-party/blah/blah.hpp \
    third-party/pugixml/pugiconfig.hpp \
    third-party/pugixml/pugixml.hpp \
    utility/BufferedVideoReader.h \
    utility/CRC8.h \
    utility/Img2Cpp.h \
    utility/sorted_interval_vector.h \
    utility/SynchronizedList.h \
    utility/SynchronizedQueue.h \
    utility/SynchronizedPriorityQueue.h \
    utility/ThreadCout.h \
    utility/Util.h \
    utility/CvUtil.h \
    utility/VideoReader.h \
	utility/Version.h

SOURCES += \
    calibration/CalibAGC.cpp \
    calibration/CalibSpatial.cpp \
    calibration/CalibTemporal.cpp \
    calibration/CalibTemporalMarker.cpp \
    common/Scenario.cpp \
    image-registration/features.cpp \
    image-registration/params.cpp \
    image-registration/registration.cpp \
    image-registration/remapping.cpp \
    resources/marker_xo_images.cpp \
    simulation/SimAGC.cpp \
    simulation/SimAWB.cpp \
    simulation/SimBayerCFA.cpp \
    simulation/SimSpatial.cpp \
    simulation/SimDisplayPWM.cpp \
    simulation/SimTemporal.cpp \
    simulation/Simulation.cpp \
    third-party/blah/blah.cpp \
    third-party/pugixml/pugixml.cpp \
    utility/BufferedVideoReader.cpp \
    utility/CRC8.cpp \
    utility/Img2Cpp.cpp \
    utility/ThreadCout.cpp \
    utility/Util.cpp \
    utility/CvUtil.cpp \
    utility/VideoReader.cpp
