/*
	Copyright (C) 2015  University of Mannheim

	This file is part of CamMark.

	CamMark is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	CamMark is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CamMark.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#ifndef __FRAME__
#define __FRAME__

class Frame
{
public:
	Frame();
	Frame(int nbr) : nbr(nbr) {}
	Frame(int nbr, double start_time, double end_time = 0, double fade_time = 0)
		: nbr(nbr), start_time(start_time), end_time(end_time), fade_time(fade_time) {}

	int getNbr() const			{ return nbr;	}	
	double getStartTime() const	{ return start_time;	}
	double getEndTime() const	{ return end_time + fade_time; }
	double getFadeTime() const	{ return fade_time; }

protected:
	int nbr;
	double start_time;
	double end_time;
	double fade_time;
};

#endif //__FRAME__