/*
	Copyright (C) 2015  University of Mannheim

	This file is part of CamMark.

	CamMark is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	CamMark is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CamMark.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#ifndef IMREG_REGISTRATION_H
#define IMREG_REGISTRATION_H

#include "features.h"
#include "params.h"

/******************************************************************
 * Structs for storing registration parameters and results
 ******************************************************************/

struct ImRegErrEstimate
{
	// Found feature points
	double num_features_lens;
	double num_features_perspective;

	// Estimated error hints
	double error_est_lens;
	double error_est_features;
};

// Register from one or more pairs of frames
ImRegParams register_frames(
	const MatVector& ref_frames, const MatVector& copy_frames,
	FeatureType lens_feature_type, FeatureType perspective_feature_type,
	int flags = 0, int keep_N_best = 0, int gridRows = 1, int gridCols = 1,
	ImRegErrEstimate *errEstimate = NULL, FrameFeaturesVector *found_features = NULL);

#endif // IMREG_REGISTRATION_H