/*
	Copyright (C) 2015  University of Mannheim

	This file is part of CamMark.

	CamMark is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	CamMark is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CamMark.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#ifndef IMREG_REMAPPING_H
#define IMREG_REMAPPING_H

// Forward declarations
class ImRegParams;
struct ImRegUndistortRectifyMaps;

// Remap a frame
void remap_frame(
	const cv::Mat& ref_frame, cv::Mat& out_frame,
	const ImRegParams& params,
	int interpolation = cv::INTER_LINEAR,
	int borderMode = 0);

// Remap a frame
void remap_frame(
	const cv::Mat& ref_frame, cv::Mat& out_frame,
	const ImRegParams& params,
	const cv::Size target_size,
	int interpolation = cv::INTER_LINEAR,
	int borderMode = 0);

// Remap a frame
void remap_frame(
	const cv::Mat& ref_frame, cv::Mat& out_frame,
	const ImRegUndistortRectifyMaps& maps,
	int interpolation = cv::INTER_LINEAR,
	int borderMode = 0);

// Remap points
void remap_points(
	cv::InputArray src, cv::OutputArray dst,
	const ImRegParams& params);

// Remap points with new source/target image sizes
void remap_points(
	cv::InputArray src, cv::OutputArray dst,
	const cv::Size sourceImgSize, const cv::Size targetImgSize, 
	const ImRegParams& params);

#endif // IMREG_REMAPPING_H
