/*
	Copyright (C) 2015  University of Mannheim

	This file is part of CamMark.

	CamMark is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	CamMark is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CamMark.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#ifndef __CAMMARK_SIMULATION__
#define __CAMMARK_SIMULATION__

#include "../stdafx.h"

#include "../utility/Util.h"
#include "../utility/VideoReader.h"
#include "../utility/BufferedVideoReader.h"
#include "../utility/sorted_interval_vector.h"
#include "../utility/SynchronizedList.h"
#include "../utility/SynchronizedQueue.h"
#include "../utility/SynchronizedPriorityQueue.h"
#include "../utility/ThreadCout.h"
#include "../utility/Version.h"

#include "../common/Scenario.h"
#include "../common/FrameSequence.h"
#include "../common/Frame.h"

#include "../simulation/SimSpatial.h"
#include "../simulation/SimBayerCFA.h"
#include "../simulation/SimDisplayPWM.h"
#include "../simulation/SimTemporal.h"
#include "../simulation/SimAWB.h"
#include "../simulation/SimAGC.h"
#include "../simulation/Simulation.h"

#endif //__CAMMARK_SIMULATION__