/*
	Copyright (C) 2015  University of Mannheim

	This file is part of CamMark.

	CamMark is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	CamMark is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CamMark.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#ifndef __SIM_AGC__
#define __SIM_AGC__

class Simulation_AGC
{
public:
	Simulation_AGC(void);
	~Simulation_AGC(void);

	void setup(
		Scenario::AGCMethod method,
		unsigned int frameCountLower, unsigned int frameCountUpper,
		float threshLower, float threshUpper,
		float adjustLower, float adjustUpper);

	void processFrame(cv::Mat &frame);

protected:
	Scenario::AGCMethod method;

	unsigned int frameCountLower, frameCountUpper;
	float threshLower, threshUpper;
	float adjustLower, adjustUpper;

	unsigned int cnt_lower, cnt_upper;
	
	float lum_last;
	float gain_offset;
	
	cv::Mat frame_ycrcb;
	std::vector<cv::Mat> ycrcbChannels;
};

#endif // __SIM_AGC__