/*
	Copyright (C) 2015  University of Mannheim

	This file is part of CamMark.

	CamMark is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	CamMark is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CamMark.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#ifndef __SIM_AWB__
#define __SIM_AWB__

class Simulation_AWB
{
	typedef std::vector<std::pair<int, cv::Point>> BrightnessPoints ;

public:
	static void grayWorld( cv::Mat& input, cv::Mat& dest ) ;
	static void weng( cv::Mat&, cv::Mat& ) ;

protected:
	static std::vector<cv::Point> wengGetReferencePoints( cv::Mat&, std::vector<cv::Point>& ) ;
	static std::vector<double> wengCalcMeanAbsDiff( cv::Mat, int, int ) ;
};

#endif //__SIM_AWB__