/*
	Copyright (C) 2015  University of Mannheim

	This file is part of CamMark.

	CamMark is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	CamMark is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CamMark.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#ifndef __SIM_DISPLAYPWM__
#define __SIM_DISPLAYPWM__

class Simulation_DisplayPWM
{
public:
	Simulation_DisplayPWM();

	// Sets up a rectangular PWM pulse signal
	void setup(double pwmDutyCycle,
			   double pwmFrequency = 180.0);

	// Integrates over a rectangular PWM pulse signal
	double integrate(double startTime,
					 double endTime) const;

protected:
	double integrate_one_period(
		unsigned int periodIdx, double startTime, double endTime) const;

	double integrate_start_period(
		unsigned int periodIdx, double time) const;

	double integrate_end_period(
		unsigned int periodIdx, double time) const;

protected:
	double pwmDutyCycle;
	double pwmDuration;

protected:
	static double pwmHighValue;
};

#endif //__SIM_DISPLAYPWM__