/*
	Copyright (C) 2015  University of Mannheim

	This file is part of CamMark.

	CamMark is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	CamMark is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CamMark.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#ifndef __STDAFX__
#define __STDAFX__

// C++ standard library
#include <string>
#include <fstream>
#include <iostream>
#include <iomanip>
#include <functional>
#include <exception>
#include <numeric>
#include <bitset>
#include <vector>
#include <algorithm>
#include <iterator>
#include <utility>
#include <queue>
#include <atomic>

// Boost includes
#include <boost/thread.hpp>
#include <boost/timer/timer.hpp>
#include <boost/filesystem.hpp>
#include <boost/algorithm/string/join.hpp>

// OpenCV includes
#include <opencv2/opencv.hpp>
#include <opencv2/gpu/gpu.hpp>

// Image registration
#include "image-registration/registration.h"
#include "image-registration/remapping.h"

// Third-party: PugiXML
#include "third-party/pugixml/pugixml.hpp"

// Platform specific
#ifdef _WIN32

#include <SDKDDKVer.h>
#include <tchar.h>
#define WIN32_LEAN_AND_MEAN
#include <Windows.h>

#define ISNAN(x) _isnan(x)

#else

#define _TCHAR char
#define _tmain main

#define ISNAN(x) std::isnan(x)

#include <sys/types.h>

#endif


#endif // __STDAFX__
