/*
	Copyright (C) 2015  University of Mannheim

	This file is part of CamMark.

	CamMark is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	CamMark is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CamMark.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#ifndef __CRC8__
#define __CRC8__

class CRC8
{
public:
	CRC8(void);
	
	// For a byte array whose accumulated crc value is stored in *crc, computes
	// resultant crc obtained by appending m to the byte array
	void crc8(unsigned char *crc, unsigned char m);

	// Append 24bit data with 8bit crc
	unsigned int append_24bit_8bitcrc(unsigned int data24bit);

	// Check 24bit data plus appended 8bit crc
	bool check_24bit_8bitcrc(unsigned int data24bit_8bitcrc);

protected:
	//8-bit table
	unsigned char crc8_table2[256];
};

#endif //__CRC8__