/*
	Copyright (C) 2015  University of Mannheim

	This file is part of CamMark.

	CamMark is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	CamMark is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with CamMark.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#ifndef __IMG2CPP__
#define __IMG2CPP__

namespace Img2Cpp
{
	// Load an image from file, compress it to PNG in memory,
	// and create C++ code that stores the data in an array.
	void createCppFromImage_PNG(
		std::string image_file, std::string name,
		std::string out_file, bool append_file = false);

	// Load an image from an array holding PNG compressed
	// image data, and the size of the array/data. Both is
	// written to a C++ file with the previous function.
	cv::Mat loadImageFromArray_PNG(
		unsigned char data[], size_t data_size);
};

#endif //__CRC8__